"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Portal = exports.version = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = require("react-dom");

function isPromise(obj) {
  return !!obj && (typeof obj === "object" || typeof obj === "function") && typeof obj.then === "function";
}

var version = "1.2.0";
exports.version = version;

var Portal = /*#__PURE__*/function (_React$Component) {
  (0, _inheritsLoose2.default)(Portal, _React$Component);

  function Portal() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "unmount", false);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "mounted", false);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "seqId", 1);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "state", {
      container: null
    });
    return _this;
  }

  Portal.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, nextState) {
    return {
      container: nextProps.container && isPromise(nextProps.container) ? nextState.container : nextProps.container
    };
  };

  var _proto = Portal.prototype;

  _proto.componentDidUpdate = function componentDidUpdate() {
    var _this2 = this;

    this.seqId++;

    if (isPromise(this.props.container)) {
      var currentSeqId = this.seqId;
      this.props.container.then(function (newContainer) {
        if (_this2.unmount || _this2.state.container === newContainer || _this2.seqId !== currentSeqId) {
          return;
        }

        if (!_this2.mounted && newContainer && _this2.props.onChildrenMount) {
          _this2.mounted = true;

          _this2.props.onChildrenMount();
        }

        _this2.setState({
          container: newContainer
        });
      });
    } else if (this.props.container) {
      if (!this.mounted && this.props.onChildrenMount) {
        this.mounted = true;
        this.props.onChildrenMount();
      }
    }
  };

  _proto.componentDidMount = function componentDidMount() {
    if (this.props.container && !isPromise(this.props.container) && this.props.onChildrenMount) {
      this.mounted = true;
      this.props.onChildrenMount();
    }

    this.componentDidUpdate();
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.unmount = true;
  };

  _proto.render = function render() {
    var container = this.state.container;
    if (!container) return null;
    return (0, _reactDom.createPortal)(this.props.children, container);
  };

  return Portal;
}(_react.default.Component);

exports.Portal = Portal;
(0, _defineProperty2.default)(Portal, "defaultProps", {
  container: typeof document !== "undefined" ? document.body : null
});
var _default = Portal;
exports.default = _default;