import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React from "react";
import { createPortal } from "react-dom";

function isPromise(obj) {
  return !!obj && (typeof obj === "object" || typeof obj === "function") && typeof obj.then === "function";
}

export var version = "1.2.0";
export var Portal = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Portal, _React$Component);

  function Portal() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "unmount", false);

    _defineProperty(_assertThisInitialized(_this), "mounted", false);

    _defineProperty(_assertThisInitialized(_this), "seqId", 1);

    _defineProperty(_assertThisInitialized(_this), "state", {
      container: null
    });

    return _this;
  }

  Portal.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, nextState) {
    return {
      container: nextProps.container && isPromise(nextProps.container) ? nextState.container : nextProps.container
    };
  };

  var _proto = Portal.prototype;

  _proto.componentDidUpdate = function componentDidUpdate() {
    var _this2 = this;

    this.seqId++;

    if (isPromise(this.props.container)) {
      var currentSeqId = this.seqId;
      this.props.container.then(function (newContainer) {
        if (_this2.unmount || _this2.state.container === newContainer || _this2.seqId !== currentSeqId) {
          return;
        }

        if (!_this2.mounted && newContainer && _this2.props.onChildrenMount) {
          _this2.mounted = true;

          _this2.props.onChildrenMount();
        }

        _this2.setState({
          container: newContainer
        });
      });
    } else if (this.props.container) {
      if (!this.mounted && this.props.onChildrenMount) {
        this.mounted = true;
        this.props.onChildrenMount();
      }
    }
  };

  _proto.componentDidMount = function componentDidMount() {
    if (this.props.container && !isPromise(this.props.container) && this.props.onChildrenMount) {
      this.mounted = true;
      this.props.onChildrenMount();
    }

    this.componentDidUpdate();
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.unmount = true;
  };

  _proto.render = function render() {
    var container = this.state.container;
    if (!container) return null;
    return createPortal(this.props.children, container);
  };

  return Portal;
}(React.Component);

_defineProperty(Portal, "defaultProps", {
  container: typeof document !== "undefined" ? document.body : null
});

export default Portal;