import React from "react";
export declare const version = "%VERSION%";
export interface PortalProps {
    /** 渲染容器，默认为：document.body */
    container?: HTMLElement | Promise<HTMLElement | null> | null;
    /** 初始渲染时触发，注：如果container为null时不会触发，直到container存在 */
    onChildrenMount?: () => void;
}
interface PortalState {
    container: HTMLElement | null;
}
export declare class Portal extends React.Component<PortalProps, PortalState> {
    static defaultProps: PortalProps;
    static getDerivedStateFromProps(nextProps: PortalProps, nextState: PortalState): {
        container: HTMLElement | null | undefined;
    };
    protected unmount: boolean;
    protected mounted: boolean;
    protected seqId: number;
    state: {
        container: null;
    };
    componentDidUpdate(): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): React.ReactPortal | null;
}
export default Portal;
